"use strict";(self.webpackChunkmaap_help_jupyter_extension=self.webpackChunkmaap_help_jupyter_extension||[]).push([[858],{858:(t,e,s)=>{s.r(e),s.d(e,{default:()=>B});var n=s(604),o=s(290),a=s(629),r=s(809),i=s(72),l=s.n(i),u=s(646);l()(u.A,{insert:"head",singleton:!1}),u.A.locals;var d=s(893),c=s.n(d);const h={id:"jupyterlab-tour:maap-tour",label:"MAAP tour",hasHelpEntry:!0,steps:[{content:"The following tutorial will point out some of the MAAP jupyter extension features within JupyterLab.",placement:"center",target:"#jp-main-dock-panel",title:"Welcome to MAAP!"},{content:"Pause the tour by clicking anywhere outside of the tooltip and resume the tour by clicking on the blue dot. Tours can be restarted in the help menu.",placement:"center",target:"#jp-main-dock-panel",title:"Some information on the tour, first"},{content:"General help menu with additional MAAP-specific information and the option to rerun this tutorial.",placement:"bottom",target:"#Help",title:"Help"},{content:"Users may submit jobs through the submit tab and view their jobs through the view tab.",placement:"bottom",target:"#Jobs",title:"Jobs"},{content:c().createElement("div",null,"The file browser is divided into your public and private buckets. Everything in the public and private buckets is persistent and s3-backed. Other MAAP users can access data in your public bucket through shared-buckets. See more ",c().createElement("a",{href:"https://docs.maap-project.org/en/latest/system_reference_guide/share_data.html",target:"_blank",style:{color:"blue"}},"here"),"."),placement:"right",target:"#filebrowser",title:"File Browser"},{content:c().createElement("div",null,"Interface with Git including cloning a repository. See more ",c().createElement("a",{href:"https://docs.maap-project.org/en/latest/system_reference_guide/work_with_git.html",target:"_blank",style:{color:"blue"}},"here"),"."),placement:"bottom",target:"#jpgitsessions",title:"Git"},{content:c().createElement("div",null,"The status bar at the bottom states your workspace's memory capacity which can be increased or decreased by manually configuring the workspace devfile. See more ",c().createElement("a",{href:"https://docs.maap-project.org/en/latest/system_reference_guide/create_workspace.html",target:"_blank",style:{color:"blue"}},"here"),"."),placement:"left",target:"#jp-bottom-panel",title:"Status Bar"},{content:"This concludes the tour. Enjoy MAAP!",placement:"center",target:"#jp-main-dock-panel",title:"Tour finished!"}]};var p=s(112);class m extends p.Widget{constructor(){let t=document.createElement("div");t.style.display="flex",t.style.flexDirection="column",t.style.height="450px",t.style.width="600px",t.innerHTML="\n        <h1>\n        <img width='575' height='150' src = 'https://maap-project.org/wp-content/uploads/2021/10/nasamaaplogo3.png'></img>\n        <br>\n        About \n        </h1>\n        <body>\n        <h2>The MAAP Project (Multi-Mission Algorithm and Analysis Platform)</h2>\n        <p><b>The MAAP platform is designed to combine data, algorithms, and computational abilities \n        for the processing and sharing of data related to NASA's GEDI, ESA's BIOMASS, and NASA/ISRO's \n        NISAR missions.</b> These missions generate vastly greater amounts of data than previous Earth \n        observation missions. There are unique challenges to processing, storing, and sharing the relevant \n        data due to the high data volume as well as with the data being collected from varied satellites, aircraft, and ground\n        stations with different resolutions, coverages, and processing levels.</p>\n        <p><b>MAAP aims to address unique challenges by making it easier to discover and use biomass relevant data, \n        integrating the data for comparison, analysis, evaluation, and generation.</b> An algorithm development environment (ADE) \n        is used to create repeatable and sharable science tools for the research community. The software is open source and adheres \n        to ESA's and NASA's commitment to open data.</p>\n        <p><b>NASA and ESA are collaborating to further the interoperability of biomass relevant data and metadata.</b> Tools have been \n        developed to support a new approach to data stewardship and there is a data publication workflow for organizing and storing data and \n        generating metadata to be discoverable in a cloud-based centralized location. The platform and data stewardship approaches are designed to \n        ease barriers and promote collaboration between researchers, providers, curators, and experts across NASA\n        and ESA.</p>\n\n        </body>",super({node:t})}}class g extends p.Widget{constructor(){let t=document.createElement("div");t.style.display="flex",t.style.flexDirection="column",t.style.height="450px",t.style.width="600px",t.innerHTML='\n        <body>\n        <a href="https://docs.maap-project.org" target="_blank"><h1 style="color:blue;"><u>MAAP Documentation</u></h1></a>\n        <embed type="text/html" src="https://docs.maap-project.org" width=\'600\' height=\'450\'>\n        </body>',super({node:t})}}class _ extends p.Widget{constructor(){let t=document.createElement("div");t.style.display="flex",t.style.flexDirection="column",t.style.height="450px",t.style.width="600px",t.innerHTML='\n        <body>\n        <a href="https://api.maap-project.org/api/" target="_blank"><h1 style="color:blue;"><u>MAAP API</u></h1></a>\n        <embed type="text/html" src="https://api.maap-project.org/api/" width=\'600\' height=\'450\'>\n        </body>',super({node:t})}}class b extends p.Widget{constructor(){let t=document.createElement("div");t.style.display="flex",t.style.flexDirection="column",t.style.height="100px",t.style.width="250px",t.innerHTML='\n        <body>\n        <h1>Submit bugs to MAAP <a href="https://github.com/MAAP-Project/Community/issues" target="_blank"><u style="color:blue;">here</u></a>\n        </h1>\n        </body>',super({node:t})}}var f=s(692);class y extends c().Component{constructor(t){super(t),this.reset=()=>{this.setState({run:!0,index:0})},this._handleJoyrideCallback=t=>{const{status:e}=t,s=[f.XQ.FINISHED,f.XQ.SKIPPED];if(this.props.tours[this.state.index].handleTourEvent(t),s.includes(e)){this.setState({run:!1});const t=this.state.index+1;t<this.props.tours.length?this.setState({index:t,run:!0}):this.setState({index:-1})}},this.state={run:!0,index:0}}render(){return this.props.tours&&this.props.tours[this.state.index]?c().createElement(f.Ay,Object.assign({key:this.props.tours[this.state.index].id},this.props.tours[this.state.index].options,{callback:this._handleJoyrideCallback,run:this.state.run,steps:this.props.tours[this.state.index].steps})):null}}function v(t){const e=c().useRef(null);return e.current&&e.current.reset(),c().createElement(y,{ref:e,tours:t.tours})}function A(t){return c().createElement(n.UseSignal,{signal:t.tourLaunched,initialArgs:[]},((t,e)=>e&&e.length>0?c().createElement(v,{tours:e}):null))}var w=s(483);const S="jupyterlab-tour";var x;new w.Token(`${S}:ITourManager`),new w.Token(`${S}:IUserTourManager`),function(t){t.addTour=`${S}:add`,t.launch=`${S}:launch`}(x||(x={}));const D={continuous:!0,showProgress:!0,showSkipButton:!0,styles:{options:{arrowColor:"var(--jp-layout-color1)",backgroundColor:"var(--jp-layout-color1)",beaconSize:36,overlayColor:"var(--jp-dialog-background)",primaryColor:"var(--jp-brand-color1)",spotlightShadow:"var(--jp-elevation-z6)",textColor:"var(--jp-ui-font-color1)",zIndex:100}}};var k=s(644);class T{constructor(t,e,s){this.handleTourEvent=t=>{if(!t)return;const{status:e,step:s,index:n}=t;e!==this._previousStatus&&(this._previousStatus=e,this._currentStepIndex=-1,e===f.XQ.FINISHED?this._finished.emit(t):e===f.XQ.SKIPPED?this._skipped.emit(t):e===f.XQ.RUNNING?(this._currentStepIndex=0,this._started.emit(t)):e===f.XQ.ERROR&&console.error(`An error occurred with the tour at step: ${s}`)),e===f.XQ.RUNNING&&(n!==this._previousStepIndex&&(this._previousStepIndex=n,this._currentStepIndex=t.index),this._stepChanged.emit(t))},this._skipped=new k.Signal(this),this._finished=new k.Signal(this),this._started=new k.Signal(this),this._stepChanged=new k.Signal(this),this._currentStepIndex=-1,this._isDisposed=!1,this._previousStatus=f.XQ.READY,this._previousStepIndex=-1,this._steps=new Array,this._label=e,this._id=t;const{styles:n,...o}=s??{};this._options={...D,...o},this._options.styles||(this._options.styles={}),this._options.styles.options={...this._options.styles.options||{},...n?.options||{}}}get currentStepIndex(){return this._currentStepIndex}get finished(){return this._finished}get hasSteps(){return this.steps.length>0}get id(){return this._id}get isDisposed(){return this._isDisposed}get label(){return this._label}get options(){return this._options}set options(t){this._options=w.JSONExt.deepCopy(t)}get skipped(){return this._skipped}get started(){return this._started}get stepChanged(){return this._stepChanged}get steps(){return this._steps}set steps(t){this._steps=t}addStep(t){t&&this.steps.push(t)}createAndAddStep(t,e,s,n){const o={title:n,placement:s,target:t,content:e};return this.addStep(o),o}dispose(){this.isDisposed||(this._isDisposed=!0,k.Signal.clearData(this))}isRunning(){return this._currentStepIndex>=0}replaceStep(t,e){if(t<0||t>=this.steps.length)return;const s=this._steps;s[t]=e,this.steps=s}removeStep(t){return t<0||t>=this.steps.length?null:this.steps.splice(t,1)[0]}}const I="3.0.0",E=`${S}:state`;class j{constructor(t,e,s){this.createTour=(t,e,s=!0,n={})=>{if(this._tours.has(t))throw new Error(this._trans.__("Error creating new tour. TourHandler id's must be unique.\nTutorial with the id: '%1' already exists.",t));n.locale||(n.locale=this._locale);const o=new T(t,e,n);if(this._menu&&s){const t=this._menu.helpMenu.menu.addItem({args:{id:o.id},command:x.launch});this._menuItems.set(o.id,t)}this._tours.set(t,o);const a=t=>{this._rememberDoneTour(t.id)};return o.skipped.connect(a),o.finished.connect(a),o},this._forgetDoneTour=t=>{localStorage.setItem(t,"false"),this._state.toursDone.delete(t),this._stateDB.save(E,{toursDone:[...this._state.toursDone],version:I})},this._rememberDoneTour=t=>{localStorage.setItem(t,"true"),this._state.toursDone.add(t),this._stateDB.save(E,{toursDone:[...this._state.toursDone],version:I})},this._activeTours=new Array,this._isDisposed=!1,this._menuItems=new Map,this._state={toursDone:new Set,version:I},this._tourLaunched=new k.Signal(this),this._stateDB=t,this._menu=s,this._tours=new Map,this._trans=e.load("jupyterlab-tour"),this._translator=e,this._locale={back:this._trans.__("Back"),close:this._trans.__("Close"),last:this._trans.__("Done"),next:this._trans.__("Next"),open:this._trans.__("Open"),skip:this._trans.__("Skip")},this._stateDB.fetch(E).then((t=>{if(t){const e=t;e.version!==I?(this._state.toursDone=new Set,this._stateDB.save(E,{version:I,toursDone:[]})):this._state.toursDone=new Set([...e.toursDone])}}))}get activeTour(){return this._activeTours.filter((t=>t.isRunning()))[0]}get isDisposed(){return this._isDisposed}get tourLaunched(){return this._tourLaunched}get tours(){return this._tours}get translator(){return this._trans}addTour(t){try{let e=this._trans;t.translation&&(e=this._translator.load(t.translation));const s=this.createTour(t.id,e.__(t.label),!1!==t.hasHelpEntry,t.options);return t.steps.forEach((t=>{const n={...t};"string"==typeof n.title&&(n.title=e.__(n.title)),"string"==typeof n.content&&(n.content=e.__(n.content)),s.addStep(n)})),s}catch(e){return console.error(this._trans.__("Fail to add tour '%1' (%2)",t.label,t.id),e),null}}dispose(){this.isDisposed||(this._isDisposed=!0,k.Signal.clearData(this))}launch(t,e=!0){if(!t||0===t.length||this.activeTour)return Promise.resolve();let s;s="string"==typeof t[0]?t.map((t=>this._tours.get(t))):t;let o=s.filter((t=>t&&t.hasSteps));e||(o=o.filter((t=>!("true"===localStorage.getItem(t.id)))));const a=()=>{this._activeTours=o,this._tourLaunched.emit(o)};return o.length>0&&(e?a():n.Notification.info(this._trans.__("Try the %1.",o[0].label),{autoClose:1e4,actions:[{label:this._trans.__("Start now"),callback:a},{label:this._trans.__("Don't show me again"),callback:()=>{o.forEach((t=>{n.Notification.info("The MAAP tour can be accessed again from the help menu"),this._rememberDoneTour(t.id)}))}}]})),Promise.resolve()}removeTour(t){if(!t)return;let e;e="string"==typeof t?t:t.id;const s=this._tours.get(e);if(s){if(this._menu&&this._menuItems.has(e)){const t=this._menuItems.get(e);t&&this._menu.helpMenu.menu.removeItem(t),this._menuItems.delete(e)}s.dispose(),this._tours.delete(e),this._forgetDoneTour(e)}}}var M=s(520),C=s.n(M);const P=["filebrowser","jp-git-sessions"],N=["Data Search","Jobs","Help"],B={id:"maap-help",autoStart:!0,optional:[n.ICommandPalette,o.IMainMenu],activate:async(t,e,s,i,l,u)=>{let d;i=new r.StateDB,function(t,e,s,o,r){const{commands:i}=t;r=r??a.nullTranslator;const l=new j(e,r,o);i.addCommand(x.launch,{label:t=>{if(t.id){const e=l.tours.get(t.id);return l.translator.__(e.label)}return l.translator.__("Launch a Tour")},usage:l.translator.__("Launch a tour.\nIf no id provided, prompt the user.\nArguments {id: Tour ID}"),isEnabled:()=>!l.activeTour,execute:async t=>{let e=t.id;const s=void 0===t.force||t.force;if(!e){const t=await n.InputDialog.getItem({items:Array.from(l.tours.keys()),title:l.translator.__("Choose a tour")});if(!t.button.accept||!t.value)return;e=t.value}l.launch([e],s)}}),i.addCommand(x.addTour,{label:l.translator.__("Add a tour"),usage:l.translator.__("Add a tour and returns it.\nArguments {tour: ITour}\nReturns `null` if a failure occurs."),execute:t=>l.addTour(t.tour)}),s&&s.addItem({category:l.translator.__("Help"),command:x.launch});const u=document.createElement("div");document.body.appendChild(u),C().render(c().createElement(A,{tourLaunched:l.tourLaunched}),u)}(t,i,e,l,u),t.commands.execute("jupyterlab-tour:add",{tour:h}).then((t=>{d=t}));const p="help:maap-about";t.commands.addCommand(p,{label:"About MAAP",isEnabled:()=>!0,execute:t=>{(0,n.showDialog)({body:new m,focusNodeSelector:"input",buttons:[n.Dialog.okButton({label:"Ok"})]})}}),e.addItem({command:p,category:"Help"});const f="help:maap-documentation";t.commands.addCommand(f,{label:"MAAP Documentation",isEnabled:()=>!0,execute:t=>{(0,n.showDialog)({body:new g,focusNodeSelector:"input",buttons:[n.Dialog.okButton({label:"Ok"})]})}}),e.addItem({command:f,category:"Help"});const y="help:maap-api";t.commands.addCommand(y,{label:"MAAP API",isEnabled:()=>!0,execute:t=>{(0,n.showDialog)({body:new _,focusNodeSelector:"input",buttons:[n.Dialog.okButton({label:"Ok"})]})}}),e.addItem({command:y,category:"Help"});const v="help:maap-bug-submission";t.commands.addCommand(v,{label:"MAAP Bug Submission",isEnabled:()=>!0,execute:t=>{(0,n.showDialog)({body:new b,focusNodeSelector:"input",buttons:[n.Dialog.okButton({label:"Ok"})]})}}),e.addItem({command:v,category:"Help"});const w="help:maap-tour";t.commands.addCommand(w,{label:"MAAP Tour",isEnabled:()=>!0,execute:e=>{d&&t.commands.execute("jupyterlab-tour:launch",{id:"jupyterlab-tour:maap-tour",force:!0})}}),e.addItem({command:w,category:"Help"}),function(t,e,s,n,a,r){let i=!1,l=!1;if(t instanceof o.HelpMenu)for(let n=0;n<t.items.length;n++){let o=t.items[n];"help:about"===o.command?(t.insertItem(n+1,{command:e,rank:1}),i=!0):"inspector:open"===o.command?(t.insertItem(n+1,{command:s,rank:1}),l=!0):("help:launch-classic-notebook"===o.command||"help:jupyter-forum"===o.command)&&(t.removeItem(o),n--)}i||t.addGroup([{command:e}],-1),l||t.addGroup([{command:s}],.1),t.addGroup([{command:n},{command:a},{command:r}],1e3)}(s.helpMenu,p,w,y,f,v),t.restored.then((()=>{d&&function(t){setTimeout((()=>t.commands.execute("jupyterlab-tour:launch",{id:"jupyterlab-tour:maap-tour",force:!1})),3e3);var e=Array.from(document.getElementsByTagName("div"));(e=e.filter((t=>t.textContent&&N.includes(t.textContent)))).forEach((t=>t.setAttribute("id",t.textContent?t.textContent.replace(/-|\s|\/|\&/g,""):"")));var s=Array.from(document.getElementsByClassName("lm-TabBar-tab p-TabBar-tab"));(s=s.filter((t=>function(t){const e=t.getAttribute("data-id");return e&&P.includes(e)}(t)))).forEach((t=>t.setAttribute("id",function(t){return t.getAttribute("data-id").replace(/-|\s|\/|\&|:/g,"")}(t))))}(t)})),console.log("JupyterLab extension maap_help is activated!")}}},475:(t,e,s)=>{s.d(e,{A:()=>a});var n=s(314),o=s.n(n)()((function(t){return t[1]}));o.push([t.id,".iframe-widget {\n    position: relative;\n    overflow: hidden;\n    padding-top: 56.25%;\n    height: 0;\n  }\n  \n  iframe {\n    position: absolute;\n    top: 0;\n    left: 0;\n    width: 100%;\n    height: 100%;\n    border: 0;\n  }\n  \n  .Toastify__toast-body {\n    overflow: auto;\n  }",""]);const a=o},646:(t,e,s)=>{s.d(e,{A:()=>i});var n=s(314),o=s.n(n),a=s(475),r=o()((function(t){return t[1]}));r.i(a.A),r.push([t.id,"\n",""]);const i=r}}]);